//---------------------------------------------------------------------------

#pragma hdrstop


#include <IEnet.h>
#include <windows.h>
#include <iostream>
using namespace std;

//---------------------------------------------------------------------------

#pragma argsused


int main(int argc, char* argv[])
{
  cout<<"Starting server main..."<<endl;
  HMODULE hLib;
  IEnet* pEnet=NULL;
  int ret=GetEnetFactoryEntryPoint(&hLib,(void**)&pEnet );
  if(!ret)
  {
   cout<<"Error:Could not create Enet instance!Exiting"<<endl;
   return EXIT_FAILURE;
  }

  cout<<"Enet instance created !"<<endl;
  if (pEnet->Initialize()!= 0)
    {
        fprintf (stderr, "An error occurred while initializing ENet.\n");
        return EXIT_FAILURE;
    }
    //atexit (Enet_Deinitialize);
  cout<<"Enet initialized !"<<endl;

    

    //Create Enet Server

     ENetAddress address;
     ENetHost * server;

    /* Bind the server to the default localhost.     */
    /* A specific host address can be specified by   */
    /* enet_address_set_host (& address, "x.x.x.x"); */

    address.host = ENET_HOST_ANY;
    /* Bind the server to port 1234. */
    address.port = 1234;

    server = pEnet->Host_create(& address /* the address to bind the server host to */,
                                 32      /* allow up to 32 clients and/or outgoing connections */,
                                  0      /* assume any amount of incoming bandwidth */,
                                  0      /* assume any amount of outgoing bandwidth */);
    if (server == NULL)
    {
        fprintf (stderr, 
                 "An error occurred while trying to create an ENet server host.\n");
        exit (EXIT_FAILURE);
    }
   cout<<"Host server created !"<<endl;
   

    cout<<"Polling for events..."<<endl;
    ENetEvent event;
    
    /* Wait up to 1000 milliseconds for an event. */
    while (pEnet->Host_service(server, & event, 2*60*1000) > 0)
    {
        switch (event.type)
        {
        case ENET_EVENT_TYPE_CONNECT://trigger on client 1st received pkt
            cout<<"A new client connected from :"<<endl;
            cout<< event.peer -> address.host<<" on port :"<<event.peer -> address.port<<endl;

            /* Store any relevant client information here. */
            event.peer -> data = "Client information";

            break;

        case ENET_EVENT_TYPE_RECEIVE:
            cout<<"A packet of length "<< event.packet -> dataLength<<" containing '"<<(char*)event.packet -> data;
            cout<<"' was received from "<<(char*) event.peer-> data<<" on channel "<<(int)event.channelID<<endl;

            /* Clean up the packet now that we're done using it. */
            pEnet->Packet_destroy (event.packet);
            
            break;
           
        case ENET_EVENT_TYPE_DISCONNECT:
            cout<< (char*)event.peer -> data<<" disconected.\n"<<endl;

            /* Reset the peer's client information. */

            event.peer -> data = NULL;
        }
    }
     cout<<"Polling ended."<<endl;










         //Destroy server
         pEnet->Host_destroy(server);
        pEnet->Deinitialize();
    
   cout<<"END."<<endl;
  //FIXMEdelete pEnet;

        return EXIT_SUCCESS;
}
//---------------------------------------------------------------------------
 