// EnetCli.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
  cout<<"Starting client main..."<<endl;
  HMODULE hLib;
  IEnet* pEnet=NULL;
  int ret=GetEnetFactoryEntryPoint(&hLib,(void**)&pEnet );
  if(!ret)
  {
   cout<<"Error:Could not create Enet instance!Exiting"<<endl;
   return EXIT_FAILURE;
  }

  cout<<"Enet instance created !"<<endl;
  if (pEnet->Initialize()!= 0)
    {
        cout<<"An error occurred while initializing ENet.\n"<<endl;
        return EXIT_FAILURE;
    }
    //atexit (Enet_Deinitialize);
  cout<<"Enet initialized !"<<endl;

  //CREATE ENET CLIENT
   ENetHost * client;

    client = pEnet->Host_create (NULL /* create a client host */,
                1 /* only allow 1 outgoing connection */,
                57600 / 8 /* 56K modem with 56 Kbps downstream bandwidth */,
                14400 / 8 /* 56K modem with 14 Kbps upstream bandwidth */);

    if (client == NULL)
    {
        cout<< "An error occurred while trying to create an ENet client host."<<endl;
        exit (EXIT_FAILURE);
    }
   
	ENetAddress address;
    ENetEvent event;
    ENetPeer *peer;

    /* Connect to some.server.net:1234. */
    pEnet->Address_set_host (& address, "localhost");
    address.port = 1234;

    /* Initiate the connection, allocating the two channels 0 and 1. */
    peer = pEnet->Host_connect (client, & address, 2);    
    
    if (peer == NULL)
    {
       cout<<"No available peers for initiating an ENet connection.\n"<<endl;
       exit (EXIT_FAILURE);
    }
    
    /* Wait up to 5 seconds for the connection attempt to succeed.*/
    if (pEnet->Host_service (client, & event, 5000) > 0 &&
        event.type == ENET_EVENT_TYPE_CONNECT)
    {
        cout<<"Connection to some.server.net:1234 succeeded."<<endl;
        //....
    }
    else
    {
        /* Either the 5 seconds are up or a disconnect event was */
        /* received. Reset the peer in the event the 5 seconds   */
        /* had run out without any significant event.            */
        pEnet->Peer_reset (peer);

        cout<<"Connection to some.server.net:1234 failed."<<endl;
    }

	cout<<"Sending reliable packet to peer"<<endl;
/* Create a reliable packet of size 7 containing "packet\0" */
    ENetPacket * packet = pEnet->Packet_create ("packet", 
                                              strlen ("packet") + 1, 
                                              ENET_PACKET_FLAG_RELIABLE);

    /* Extend the packet so and append the string "foo", so it now */
    /* contains "packetfoo\0"                                      */
    pEnet->Packet_resize (packet, strlen ("packetfoo") + 1);
    strcpy ((char*)& packet -> data [strlen ("packet")], "foo");
    
    /* Send the packet to the peer over channel id 3. */
    /* One could also broadcast the packet by         */
    /* enet_host_broadcast (host, 1, packet);         */
    pEnet->Peer_send (peer, 0, packet);
    //...
    /* One could just use enet_host_service() instead. */
    pEnet->Host_flush (client);







  //Destroy server
  pEnet->Host_destroy(client);
  pEnet->Deinitialize();
    
   cout<<"END."<<endl;
  //FIXMEdelete pEnet;
  return EXIT_SUCCESS;
}


